﻿-- Compleater
if not Completer then
  Completer = true;

  local frame, events = CreateFrame("Frame"), {};

  -- check skill level and skill training
  function events:CHAT_MSG_SKILL(msg)
    -- Check if there is a SKILL tag
    local skills = TG_TS_GetProfessions();
    if TourGuide.tags[TourGuide.current]:match("|SKILL|([%a:%s]+)%s?(%d+)|") then
      -- Get Skill info to check
      local _, _, SkillName, SkillLevel = TourGuide.tags[TourGuide.current]:find("|SKILL|([%a:%s]+)%s?(%d+)|");
      SkillName = trim(SkillName);
      SkillLevel = tonumber(SkillLevel) or 1;

      -- Loop all curent skill and check if the skill match
      for _, sID in ipairs(skills) do
        if sID then
          local sName, _, sLevel, _, _, _, _, _ = GetProfessionInfo(sID)
          if SkillName == sName and SkillLevel <= tonumber(sLevel) then
            TourGuide:SetTurnedIn(TourGuide.current, true);
            CurentGuide = "Update";
          end
        end
      end
    end
  end

  -- Check for new learned item recipe
  function events:CHAT_MSG_SYSTEM(msg, ...)
    --print(msg);
    -- Check if there is a TRAINSKILL tag
    if msg:match("You have learned a new ability: (.+).") and TourGuide.tags[TourGuide.current]:match("|TRAINSKILL|([%a:%s]+)%s?(%d+)|") then
      local abilityname = trim(msg:match("You .+%[(.+)%]."));
      -- Get Skill info to check
      local _, _, SkillName, MaxSkillLevel = TourGuide.tags[TourGuide.current]:find("|TRAINSKILL|([%a:%s]+)%s?(%d+)|");
      SkillName = trim(SkillName);
      -- If Ability name and skillname match
      if abilityname == SkillName then
        MaxSkillLevel = tonumber(MaxSkillLevel) or 75;

        -- Get and loop all curent skill and check if the skill match
        local skills = TG_TS_GetProfessions();
        for _, sID in ipairs(skills) do
          if sID then
            local sName, _, _, maxSLevel, _, _, _, _ = GetProfessionInfo(sID)
            if SkillName == trim(sName) and (MaxSkillLevel - 75) == tonumber(maxSLevel) or MaxSkillLevel == tonumber(maxSLevel) then
              TourGuide:SetTurnedIn(TourGuide.current, true);
              --CurentGuide = "Update";
            end
          end
        end
      end
    end

    if TourGuide.tags[TourGuide.current]:match("|LEARNITEM|([%a:%s]+)|") then
      if msg:match("You have learned how to create a new item: ([%a:%s]+).") then
        -- Get item name to learn
        local ItemName = TourGuide.tags[TourGuide.current]:match("|LEARNITEM|([%a:%s]+)|");
        -- Get item nave of just learned
        local LearnedItemName = msg:match("You have learned how to create a new item: ([%a:%s]+).");

        -- Compleate if match
        if (trim(ItemName) == trim(LearnedItemName)) then
          TourGuide:SetTurnedIn(TourGuide.current, true);
        end
      end
    end
  end

  -- Check location
  function events:ZONE_CHANGED()
    -- Check if there is a LOC tag
    if TourGuide.tags[TourGuide.current]:match("|LOC|([%w:'%s]+)|") then
      -- Get LOC location name
      local Location = TourGuide.tags[TourGuide.current]:match("|LOC|([%w:'%s]+)|");
      Location = trim(Location);

      -- Get current zone or subzone name
      NewLocation = GetMinimapZoneText();

      -- If location and new location match, update objectives
      if (Location == NewLocation) then
        TourGuide:SetTurnedIn(TourGuide.current, true);
      end
    end
  end

  -- Check location
  function events:BAG_UPDATE(bId)
    -- If bag id is 0-4 then execute script
    if bId >= 0 and bId <= 4 then
      -- Check if there is a L tag
      if TourGuide.tags[TourGuide.current]:match("|L|(%d+)%s?(%d*)|") then
        -- Get info from L tag
        local lootitem, lootqty = TourGuide.tags[TourGuide.current]:match("|L|(%d+)%s?(%d*)|");
        -- Fix Quantity
        lootqty = tonumber(lootqty) or 1;

        -- If loot quantity match the quantity to loot, update objectives
        if (GetItemCount(lootitem) >= lootqty) then
          TourGuide:SetTurnedIn(TourGuide.current, true);
          CurentGuide = "Update";
        end
      end
    end
  end

  -- Check for player level up
  function events:PLAYER_LEVEL_UP(level)
    for i, t in ipairs(TourGuide.tags) do
      lvl = tonumber(t:match("|LVL|(%d+)|"))
      if lvl and lvl <= tonumber(level) then TourGuide:SetTurnedIn(i, true) end
    end
  end

  frame:SetScript("OnEvent",
    function(self, event, ...)
      events[event](self, ...)
    end
  )

  for k, v in pairs(events) do
    frame:RegisterEvent(k)
  end
  
  local timer025, timer1, timer5, playSound, secLeft, expired = 0, 1, 5, 0, 0, 0;
  -- Table of fishing poles
  local fishpoles = {6256,6365,6366,6367,12225,19022,19970,25978,44050,45858,45991,45992,46337,52678};
  frame:SetScript("OnUpdate",
    function(Self,LastUpdate)
      -- Make sure TourGuide addon is loaded
      if IsAddOnLoaded("TourGuide") then
        -- only run this script if |U|se tag is presended
        -- This is used for warning bip when lure is almost runned out
        if TourGuide.tags[TourGuide.current]:match("|U|") then
          timer025 = timer025 + LastUpdate;
          if timer025 >= 0.25 then
            -- check if player have a fishing pole equipped
            for i,v in ipairs(fishpoles) do
              local poleName = GetItemInfo(v);
              local poleEquipped = IsEquippedItem(v);
              if poleEquipped then
                hasMainHandEnchant, mainHandExpiration = GetWeaponEnchantInfo();
                -- Play sound if fishing pole have lures on it that is soon to run out
                if hasMainHandEnchant then
                  secLeft = floor(mainHandExpiration/1000);
                  -- Show that enchant expired
                  if secLeft == 0 and expired == 0 then
                    print(string.format("|cffffff00%s|r |cFFFF6060temp enchant expired|r",poleName));
                    expired = 1;
                  -- Play bip each second
                  elseif secLeft <= 1 then
                    playSound = 1;
                  -- Play bip each second
                  elseif secLeft <= 5 then
                    timer1 = timer1 + timer025;
                    if timer1 >= 1 then
                      timer1 = timer1 - 1;
                      playSound = 1;
                      print(string.format("|cffffff00%s|r |cFFFF6060temp enchant expire in: %isec|r",poleName,secLeft));
                    end
                  -- Play bip each 5 second
                  elseif secLeft <= 20 then
                    timer5 = timer5 + timer025;
                    if timer5 >= 5 then
                      timer5 = timer5 - 5;
                      playSound = 1;
                      print(string.format("|cffffff00%s|r |cFFFF6060temp enchant expire in: %isec|r",poleName,secLeft));
                    end
                  -- Reset 1 and 5 sec counter if not reset
                  elseif secLeft > 20 and timer5 > 0 or timer1 > 0 or expired > 0 then
                    timer1 = 1;
                    timer5 = 5;
                    expired = 0;
                  end
                  if playSound == 1 then
                    PlaySoundFile("Interface\\AddOns\\TourGuide-Tradeskill\\Sounds\\bip.mp3", "Ambience");
                    playSound = 0;
                  end -- if playSound
                end -- if hasMainHandEnchant
              end -- if poleEquipped
            end -- for i,v
            timer025 = timer025 - 0.25;
          end -- if timer025
        end -- if TourGuide.tags
      end -- if IsAddOnLoaded
    end -- function
  )
end